// Definicija klase za greske (Greska).

#ifndef _greska_h_
#define _greska_h_

#include <iostream>
#include <string>
using namespace std;

namespace Usluge {
  class Greska {
    string poruka;                              // Tekst poruke.
  public:                                       // Konstruktori:
    Greska() =default;                          // - podrazumevani,
    Greska(const char* por) { poruka = por; }   // - konvertujuci.
    virtual ~Greska() {}                        // Destruktor.
    Greska& operator=(const Greska&) =delete;   // Ne moze da se dodeljuje.
  protected:
    virtual void pisi(ostream& it) const {      // Pisanje poruke o gresci.
      it << "\n*** " << (ima_poruke() ? poruka : "Greska") << " ***\n\a";
    }
    friend ostream& operator<<(ostream& it, const Greska& g)
      { g.pisi(it); return it; }
    bool ima_poruke() const                     // Ima li poruke u objektu?
      { return poruka != ""; }
  }; // class Greska
} // namespace Usluge

#endif

