// Definicija apstraktne klase za iteratore (Iter).

#ifndef _iter_h_
#define _iter_h_

#include "figura1.h"

class Iter {
public:
  virtual ~Iter() {}                            // Virtuelni destruktor.
  virtual bool ima() const =0;                  // Ima li tekueg elementa?
  virtual Iter& poc() =0;                       // Pomeranje na poetak.
  virtual const Iter& poc() const =0;
  virtual Iter& operator++() =0;                // Pomeranje korak napred.
  virtual const Iter& operator++() const =0;
  virtual Figura* operator->() =0;              // Pokaziva na figuru.
  virtual const Figura* operator->() const =0;
  Figura& operator*() { return *operator->(); } // Vrednost figure.
  const Figura& operator*() const { return *operator->(); }
  virtual Iter& operator+=(Figura* fig) =0;     // Umetanje figure.
  virtual Iter& operator+=(const Figura& fig) =0;
  virtual Iter& operator+=(Figura&& fig) =0;
  virtual Iter& operator-=(Figura*& fig) =0;    // Vaenje figure.
  Figura* operator~()                           // Vaenje figure.
    { Figura* fig; *this -= fig; return fig; }
};

#endif
