// Definicije metoda uz klasu Lista.

#include "lista2.h"
#include "liter.h"

void Lista::kopiraj(const Zbirka& z) {           // Kopiranje u listu.
  const Lista& lst = dynamic_cast<const Lista&>(z);
  prvi = posl = nullptr; duz = lst.duz;
  for (Elem* tek=lst.prvi; tek; tek=tek->sled)
    posl = (!prvi ? prvi : posl->sled) = new Elem(tek->fig->kopija());
}

void Lista::brisi() {                            // Oslobaanje memorije.
  while (prvi) {
    Elem* stari = prvi; prvi = prvi->sled;
    delete stari->fig; delete stari;
  }
  posl = nullptr; duz = 0;
}

Figura*& Lista::operator[](int ind) {            // Dohvatanje figure.
  if (ind<0 || ind >= duz) greska(G_IND);
  Elem* tek = prvi;
  for (int i=0; i<ind; i++) tek = tek->sled;
  return tek->fig;
}

Iter* Lista::iter() { return new L_iter(this); } // Stvaranje iteratora.
const Iter* Lista::iter() const { return new L_iter(this); }
