// Definicija klase iteratora za liste (L_iter).

#ifndef _liter_h_
#define _liter_h_

#include "iter.h"
#include "lista2.h"

class L_iter: public Iter {
  Lista* lst;                               // Pokaziva na listu.
  mutable Lista::Elem *preth, *tek;         // Prethodni i tekui element.
public:
  L_iter(const Lista* lis) {                // Stvaranje iteratora.
    lst = const_cast<Lista*>(lis);
    preth = nullptr; tek = lst->prvi;
  }
  bool ima() const                          // Ima li jo elemenata?
    { return tek != nullptr; }
  L_iter& poc()                             // Pomeranje na poetak.
    { preth = nullptr; tek = lst->prvi; return *this; }
  const L_iter& poc() const
    { preth = nullptr; tek = lst->prvi; return *this; }
  L_iter& operator++() {                    // Pomeranje korak napred.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    preth = tek; tek = tek->sled;
    return *this;
  }
  const L_iter& operator++() const
    { return ++const_cast<L_iter&>(*this); }
  Figura* operator->() {                    // Pokaziva na figuru.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    return tek->fig;
  }
  const Figura* operator->() const
    { return const_cast<L_iter&>(*this).operator->(); }
  L_iter& operator+=(Figura* fig) {         // Umetanje figure.
    Lista::Elem* novi = new Lista::Elem(fig, tek);
    (!preth ? lst->prvi : preth->sled) = tek;
    if (!tek) lst->posl = novi;
    return *this;
  }
  L_iter& operator+=(const Figura& fig)
    { return *this += fig.kopija(); }
  L_iter& operator+=(Figura&& fig)
    { return *this += move(fig).kopija(); }
  L_iter& operator-=(Figura*& fig) {        // Vaenje figure.
    if (!ima()) Zbirka::greska(Zbirka::G_TEK);
    fig = tek->fig;
    Lista::Elem* stari = tek;
    tek = (!preth ? lst->prvi : preth->sled) = tek->sled;
    delete stari; lst->duz--;
    return *this;
  }
};

#endif
