#include <iostream>
#include <cstdlib>
using namespace std;

class Niz {
  int poc, kraj;                             // Opseg indeksa.
  double* a;                                 // Elementi niza.
  void kopiraj(const Niz&);                  // Kopiranje u niz.
  void premesti(Niz& niz) {                  // Premestanje u niz.
    poc = niz.poc; kraj = niz.kraj;
    a = niz.a; niz.a = nullptr;
  }
  void brisi() { delete [] a; }              // Oslobadjanje memorije.
public:
  Niz(int min, int max) {                    // Konstruktori.
    if (min > max) exit(1);
    a = new double [(kraj=max)-(poc=min)+1];
  }
  Niz(const Niz& niz) { kopiraj(niz); }
  Niz(Niz&& niz) { premesti(niz); }
  ~Niz() { brisi(); }                        // Destruktor.
  Niz& operator=(const Niz& niz) {           // Dodele vrednosti.
    if (this != &niz) { brisi(); kopiraj(niz); }
    return *this;
  }
  Niz& operator=(Niz&& niz) {
    if (this != &niz) { brisi(); premesti(niz); }
    return *this;
  }
  double& operator[](int i) {                // DOHVATANJE ELEMENTA.
    if (i<poc || i>kraj) exit(2);
    return a[i-poc];
  }
  const double& operator[](int i) const {
    if (i<poc || i>kraj) exit(2);
    return a[i-poc];
  }
};

void Niz::kopiraj(const Niz& niz) {          // Kopiranje.
  a = new double [(kraj=niz.kraj)-(poc=niz.poc)+1];
  for (int i=0; i<kraj-poc+1; i++) a[i] = niz.a[i];
}

int main() {
  Niz niz(-5, 5);
  for (int i=-5; i<=5; i++) niz[i]=i;
//  *(niz+4) = 4;              // GRESKA: ne vazi adresna aritmetika!
  const Niz c_niz = niz;
//  c_niz = niz;               // GRESKA: menjanje celog nepromenljivog niza!
//  c_niz[2] = 55;             // GRESKA: menjanje dela nepromenljivog niza!
  double a = c_niz[2];       // U redu: uzimanje je dozvoljeno.
}

